package org.jboss.cache.marshall;

import org.jboss.util.stream.MarshalledValueInputStream;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OutputStream;

/**
 * Standard Java implementation of ObjectStreamFactory
 *
 * @author Clebert Suconic
 * @author <a href="mailto:galder.zamarreno@jboss.com">Galder Zamarreno</a>
 * @since 1.4.1
 */
class JavaObjectStreamFactory implements ObjectStreamFactory
{

   public ObjectInputStream createObjectInputStream(byte[] bytes) throws IOException
   {
      ByteArrayInputStream in = new ByteArrayInputStream(bytes);
      return new MarshalledValueInputStream(in);
   }

   public ObjectInputStream createObjectInputStream(InputStream in) throws IOException
   {
      return new MarshalledValueInputStream(in);
   }

   public ObjectOutputStream createObjectOutputStream(OutputStream out) throws IOException
   {
      return new ObjectOutputStream(out);
   }

}
